using System;
using System.Collections.Generic;
using System.Text;
using EnvDTE;
using EnvDTE80;

namespace DemoAddin
{
	static class ProjectStructureHelper
	{
		public static HierarchyItem ExploreProject( Project project )
		{
			HierarchyItem objHierarchyItem = new HierarchyItem();
			try
			{
				objHierarchyItem.Text = "Project "+project.Name;
			}
			catch
			{
				objHierarchyItem.Text = "Project";
				return objHierarchyItem;
			}

			AddProjectItems( objHierarchyItem, project.ProjectItems );
			return objHierarchyItem;
		}
		public static void AddProjectItems( HierarchyItem parent, ProjectItems projectItems )
		{
			if (projectItems == null)
				return;

			try
			{
				foreach (ProjectItem objProjectItem in projectItems)
					parent.Children.Add( ExploreProjectItem( objProjectItem ) );
			}
			catch
			{
			}
		}

		public static HierarchyItem ExploreProjectItem( ProjectItem projectItem )
		{
			HierarchyItem objHierarchyItem = new HierarchyItem();
			try
			{
				objHierarchyItem.Text = projectItem.Name;
			}
			catch
			{
				objHierarchyItem.Text = "(unknown project item)";
				return objHierarchyItem;
			}
			try
			{
				if (projectItem.ProjectItems != null)
				{
					foreach (ProjectItem objProjectItem in projectItem.ProjectItems)
						objHierarchyItem.Children.Add( ExploreProjectItem( objProjectItem ) );
				}
			}
			catch
			{
				// ignore
			}
			return objHierarchyItem;
		}
	}
}
