using System;
using System.Collections.Generic;
using System.Text;

namespace DemoAddin
{
	/// <summary>
	/// Represents an element of the hierarchy that is displayed in the tool window's tree view.
	/// </summary>
	public class HierarchyItem
	{
		private List<HierarchyItem> m_lstChildren = new List<HierarchyItem>();
		private string m_strText;

		/// <summary>
		/// Gets the children.
		/// </summary>
		/// <value>The children.</value>
		public List<HierarchyItem> Children
		{
			get { return m_lstChildren;}
		}

		/// <summary>
		/// Gets or sets the text.
		/// </summary>
		/// <value>The text.</value>
		public string Text
		{
			get { return m_strText; }
			set { m_strText = value; }
		}

		/// <summary>
		/// Initializes a new instance of the <see cref="HierarchyItem"/> class.
		/// </summary>
		public HierarchyItem()
		{
			m_strText = String.Empty;
		}

		/// <summary>
		/// Initializes a new instance of the <see cref="HierarchyItem"/> class.
		/// </summary>
		/// <param name="text">The display text of the item.</param>
		public HierarchyItem(string text)
		{
			m_strText = text;
		}
	}
}
